import logging


class Configuration(object):
    log = logging.getLogger('partek.Configuration')

    def __init__(self):
        self._start_plugin_json = ''
        self._basecaller_dir = ''
        self._alignment_dir = ''
        self._reference_path = ''
        self._barcode_filter = ''
        self._run_name = ''
        self._plugin_dir = ''
        self._result_dir = ''
        self.__flow_password = ''
        self.__flow_project = ''
        self.__flow_server = ''
        self.__flow_username = ''

    @property
    def start_plugin_json(self):
        return self._start_plugin_json

    @start_plugin_json.setter
    def start_plugin_json(self, value):
        self.log.info('startplugin.json path: %s', value)
        self._start_plugin_json = value

    @property
    def basecaller_dir(self):
        return self._basecaller_dir

    @basecaller_dir.setter
    def basecaller_dir(self, value):
        self.log.info('basecaller dir: %s', value)
        self._basecaller_dir = value

    @property
    def alignment_dir(self):
        return self._alignment_dir

    @alignment_dir.setter
    def alignment_dir(self, value):
        self.log.info('alignment dir: %s', value)
        self._alignment_dir = value

    @property
    def barcode_filter(self):
        return self._barcode_filter

    @barcode_filter.setter
    def barcode_filter(self, value):
        self.log.info('Barcode filter file: %s', value)
        self._barcode_filter = value

    @property
    def run_name(self):
        return self._run_name

    @run_name.setter
    def run_name(self, value):
        self.log.info('Run name: %s', value)
        self._run_name = value

    @property
    def reference_path(self):
        return self._reference_path

    @reference_path.setter
    def reference_path(self, value):
        self.log.info('Reference sequence: %s', value)
        self._reference_path = value

    @property
    def result_dir(self):
        return self._result_dir

    @result_dir.setter
    def result_dir(self, value):
        self.log.info('Result dir: %s', value)
        self._result_dir = value

    @property
    def plugin_dir(self):
        return self._plugin_dir

    @plugin_dir.setter
    def plugin_dir(self, value):
        self.log.info('Plugin dir: %s', value)
        self._plugin_dir = value

    @property
    def flow_username(self):
        return self.__flow_username

    @flow_username.setter
    def flow_username(self, value):
        self.log.info('Partek Flow user: %s', value)
        self.__flow_username = value

    @property
    def flow_password(self):
        return self.__flow_password

    @flow_password.setter
    def flow_password(self, value):
        self.__flow_password = value

    @property
    def flow_server(self):
        return self.__flow_server

    @flow_server.setter
    def flow_server(self, value):
        self.log.info('Partek Flow server: %s', value)
        self.__flow_server = value

    @property
    def flow_project(self):
        return self.__flow_project

    @flow_project.setter
    def flow_project(self, value):
        self.log.info('Partek Flow project: %s', value)
        self.__flow_project = value
