import unittest
import partek.plugin.Configuration


class TestConfiguration(unittest.TestCase):

    def test_setting_properties(self):
        test_conf = partek.plugin.Configuration()
        self.assertEqual('', test_conf.flow_username)
        self.assertEqual('', test_conf.flow_password)
        self.assertEqual('', test_conf.flow_server)
        self.assertEqual('', test_conf.flow_project)
        test_conf.flow_username = 'guest'
        test_conf.flow_password = 'password'
        test_conf.flow_server = 'http://localhost:8080'
        test_conf.flow_project = 'UnitTest Project'
        self.assertEqual('guest', test_conf.flow_username)
        self.assertEqual('password', test_conf.flow_password)
        self.assertEqual('http://localhost:8080', test_conf.flow_server)
        self.assertEqual('UnitTest Project', test_conf.flow_project)

        self.assertEqual('', test_conf.start_plugin_json)
        self.assertEqual('', test_conf.basecaller_dir)
        self.assertEqual('', test_conf.alignment_dir)
        self.assertEqual('', test_conf.reference_path)
        self.assertEqual('', test_conf.barcode_filter)
        self.assertEqual('', test_conf.run_name)
        test_conf.basecaller_dir = '/fake/path/to/basecaller/dir'
        test_conf.alignment_dir = '/fake/path/to/alignment/dir'
        test_conf.barcode_filter = '/fake/path/to/barcode/filter/txt'
        test_conf.run_name = 'test_run_name'
        test_conf.reference_path = '/fake/path/to/reference/genome'
        self.assertEqual('/fake/path/to/basecaller/dir', test_conf.basecaller_dir)
        self.assertEqual('/fake/path/to/alignment/dir', test_conf.alignment_dir)
        self.assertEqual('/fake/path/to/barcode/filter/txt', test_conf.barcode_filter)
        self.assertEqual('test_run_name', test_conf.run_name)
        self.assertEqual('/fake/path/to/reference/genome', test_conf.reference_path)

